DECLARE FUNCTION multikey% (t%)
DEFINT A-Z

' GAMEPLAY CONSTANTS

CONST gravity = .1
CONST characcel = .2
CONST topspeed = 1.6
CONST jump = 3


SCREEN 13
CLS

' DECLARATIONS

DIM sprite(193, 150) AS INTEGER          'max sprites in this segment
DIM mask(193, 150) AS INTEGER


' INITIALIZATION

OPEN "kofman/SPRITE.TIL" FOR BINARY AS #1

'LOAD IN THE PALETTE
length = LOF(1) - 768


DIM colorval AS LONG
FOR col = 0 TO 255
   GET #1, length + (col * 3) + 1, R%
   GET #1, length + (col * 3) + 2, G%
   GET #1, length + (col * 3) + 3, b%

   R% = R% AND 63
   G% = G% AND 63
   b% = b% AND 63

   colorval& = R% + (G% * 256) + (b% * 65536)

   PALETTE col, colorval&
NEXT

FOR sprt% = 0 TO (length / 386) - 1
   sprite%(0, sprt%) = 128
   sprite%(1, sprt%) = 24

   FOR byte% = 2 TO 193
      GET #1, (sprt% * 386) + 3 + ((byte% - 2) * 2), temp%
      sprite%(byte%, sprt%) = temp%
   NEXT
NEXT


CLOSE #1

OPEN "kofman/MASKs.TIL" FOR BINARY AS #1

length = LOF(1) - 768
FOR sprt% = 0 TO (length / 386) - 1
   mask%(0, sprt%) = 128
   mask%(1, sprt%) = 24

   FOR byte% = 2 TO 193
      GET #1, (sprt% * 386) + 3 + ((byte% - 2) * 2), temp%
      mask%(byte%, sprt%) = temp%
   NEXT
NEXT

CLOSE #1
    

' ANIMATION LOOP

plrX! = 100
plrY! = 100
plrXvel! = 0
plrYvel! = 0

dummy = multikey(-1)


DO
   plrX! = plrX! + plrXvel!
   plrY! = plrY! + plrYvel!

   IF plrY! < 199 THEN
      plrYvel! = plrYvel! + gravity
   ELSE
      plrY! = 199
      plrYvel! = 0
   END IF

   IF multikey(77) THEN
      plrXvel! = plrXvel! + characcel
      IF plrXvel! > topspeed THEN plrXvel! = topspeed
   END IF
   IF multikey(75) THEN
      plrXvel! = plrXvel! - characcel
      IF plrXvel! < -topspeed THEN plrXvel! = -topspeed
   END IF

   IF multikey(72) AND plrY! = 199 THEN
      plrYvel! = -jump
   END IF


   PUT (INT(plrX!) - 8, INT(plrY!) - 24), mask%(0, 0), AND
   PUT (INT(plrX!) - 8, INT(plrY!) - 24), sprite%(0, 0), OR

   WAIT &H3DA, 8, 8
   WAIT &H3DA, 8
LOOP UNTIL multikey(1)

dummy = multikey(-2)

FUNCTION multikey (t)
STATIC kbcontrol%(), kbmatrix%(), Firsttime, StatusFlag

IF Firsttime = 0 THEN          'Initalize
 DIM kbcontrol%(128)
 DIM kbmatrix%(128)
 code$ = ""
 code$ = code$ + "E91D00E93C00000000000000000000000000000000000000000000000000"
 code$ = code$ + "00001E31C08ED8BE24000E07BF1400FCA5A58CC38EC0BF2400B85600FAAB"
 code$ = code$ + "89D8ABFB1FCB1E31C08EC0BF2400BE14000E1FFCFAA5A5FB1FCBFB9C5053"
 code$ = code$ + "51521E560657E460B401A8807404B400247FD0E088C3B700B0002E031E12"
 code$ = code$ + "002E8E1E100086E08907E4610C82E661247FE661B020E6205F075E1F5A59"
 code$ = code$ + "5B589DCF"
 DEF SEG = VARSEG(kbcontrol%(0))

 FOR i% = 0 TO 155                     ' Load ASM
     d% = VAL("&h" + MID$(code$, i% * 2 + 1, 2))
     POKE VARPTR(kbcontrol%(0)) + i%, d%
 NEXT i%
 i& = 16       ' I think this stuff connects the interrupt with kbmatrix%()
 n& = VARSEG(kbmatrix%(0)): l& = n& AND 255: h& = ((n& AND &HFF00) \ 256): POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
 n& = VARPTR(kbmatrix%(0)): l& = n& AND 255: h& = ((n& AND &HFF00) \ 256): POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
 DEF SEG
 Firsttime = 1

END IF

SELECT CASE t
 CASE -1
  IF StatusFlag = 0 THEN
   DEF SEG = VARSEG(kbcontrol%(0))

   CALL ABSOLUTE(0)                     ' Run interrupt
   DEF SEG
   StatusFlag = 1

  END IF
 CASE -2
  IF StatusFlag = 1 THEN
   DEF SEG = VARSEG(kbcontrol%(0))      ' Turn off interrupt
   CALL ABSOLUTE(3)
   DEF SEG
   StatusFlag = 0

  END IF
 CASE 1 TO 128
  multikey = kbmatrix%(t)               ' Return status
 CASE ELSE
  multikey = 0                          ' User Supidity Error
END SELECT

END FUNCTION

